Subject: Re: [PATCH] t7510: do not fail when gpg warns about insecure memory

From: Michael J Gruber <[email-masked]>
Date: Mon, 09 Mar 2015 10:47:14 +0100

Kyle J. McKay venit, vidit, dixit 09.03.2015 06:32:
> On Mar 8, 2015, at 18:22, brian m. carlson wrote:
> 
>> On Sun, Mar 08, 2015 at 06:15:55PM -0400, Eric Sunshine wrote:
>>> On Sun, Mar 8, 2015 at 6:04 PM, brian m. carlson
>>> <[email-masked]> wrote:
>>>> Perhaps this is better?
>>>>
>>>> Unfortunately when running the test, that message is found in the   
>>>> standard
>>>> output of git show -s --show-signature, but in the standard  error  
>>>> of git
>>>> verify-commit -v causing the comparisons of both standard  output  
>>>> and
>>>> standard error to fail.
>>>
>>> That doesn't help me parse it any better.  It's the "but" without a
>>> corresponding "not" which seems to be throwing me off. Typically, one
>>> would write "this but not that" or "not this but that". I can't tell
>>> if there is a "not" missing or if the "but" is supposed to be an  
>>> "and"
>>> or if something else was intended.
>>
>> The intended meaning is "and" with the additional sense of contrast.  
>> The sentence, if read with verbal emphasis, is, "…is found in the  
>> standard *output* of git show -s --signature, but in the standard  
>> *error* of git verify-commit -v", thus demonstrating why the test  
>> fails: the pairs of output files don't match up.
>>
>> Maybe you can suggest a less confusing wording.
> 
> I like Brian's wording, but how about this slight variation, does this  
> parse any better for you?
> 
> Unfortunately when running the test, while that message is found in
> the standard output of git show -s --show-signature, it is found in
> the standard error of git verify-commit -v causing the comparisons
> of both standard output and standard error to fail.
> 
> -Kyle
> 

That still makes it sound as if we'd rather fix "git show" than adjust
the test to such surprising behavior.

But in fact, "git verify-commit" uses stdout and stderr to separate its
output appropriately, whereas "git show" lumps everything together on
stdout, so that the test has to split it up again.

Now, if I read it correctly, the patch suggests ignoring the insecure
memory warning from both outputs rather than putting it on the correct
side of the split.

I'd rather put it on the correct side (or silence gpg by setting its
config).

Michael